<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ZKUtil.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">ZKUtil.java</span></div><h1>ZKUtil.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.zookeeper;

import java.util.ArrayList;
import java.util.Deque;
import java.util.LinkedList;
import java.util.List;

import org.apache.zookeeper.AsyncCallback.VoidCallback;
import org.apache.zookeeper.common.PathUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
         
<span class="nc" id="L30">public class ZKUtil {</span>
<span class="fc" id="L31">    private static final Logger LOG = LoggerFactory.getLogger(ZKUtil.class);</span>
    /**
     * Recursively delete the node with the given path. 
     * &lt;p&gt;
     * Important: All versions, of all nodes, under the given node are deleted.
     * &lt;p&gt;
     * If there is an error with deleting one of the sub-nodes in the tree, 
     * this operation would abort and would be the responsibility of the app to handle the same.
     * 
     * See {@link #delete(String, int)} for more details.
     * 
     * @throws IllegalArgumentException if an invalid path is specified
     */
    public static void deleteRecursive(ZooKeeper zk, final String pathRoot)
        throws InterruptedException, KeeperException
    {
<span class="fc" id="L47">        PathUtils.validatePath(pathRoot);</span>
      
<span class="fc" id="L49">        List&lt;String&gt; tree = listSubTreeBFS(zk, pathRoot);</span>
<span class="fc" id="L50">        LOG.debug(&quot;Deleting &quot; + tree);</span>
<span class="fc" id="L51">        LOG.debug(&quot;Deleting &quot; + tree.size() + &quot; subnodes &quot;);</span>
<span class="fc bfc" id="L52" title="All 2 branches covered.">        for (int i = tree.size() - 1; i &gt;= 0 ; --i) {</span>
            //Delete the leaves first and eventually get rid of the root
<span class="fc" id="L54">            zk.delete(tree.get(i), -1); //Delete all versions of the node with -1.</span>
        }
<span class="fc" id="L56">    }</span>
    

    /**
     * Recursively delete the node with the given path. (async version).
     * 
     * &lt;p&gt;
     * Important: All versions, of all nodes, under the given node are deleted.
     * &lt;p&gt;
     * If there is an error with deleting one of the sub-nodes in the tree, 
     * this operation would abort and would be the responsibility of the app to handle the same.
     * &lt;p&gt;
     * @param zk the zookeeper handle
     * @param pathRoot the path to be deleted
     * @param cb call back method
     * @param ctx the context the callback method is called with
     * @throws IllegalArgumentException if an invalid path is specified
     */
    public static void deleteRecursive(ZooKeeper zk, final String pathRoot, VoidCallback cb,
        Object ctx)
        throws InterruptedException, KeeperException
    {
<span class="fc" id="L78">        PathUtils.validatePath(pathRoot);</span>
      
<span class="fc" id="L80">        List&lt;String&gt; tree = listSubTreeBFS(zk, pathRoot);</span>
<span class="fc" id="L81">        LOG.debug(&quot;Deleting &quot; + tree);</span>
<span class="fc" id="L82">        LOG.debug(&quot;Deleting &quot; + tree.size() + &quot; subnodes &quot;);</span>
<span class="fc bfc" id="L83" title="All 2 branches covered.">        for (int i = tree.size() - 1; i &gt;= 0 ; --i) {</span>
            //Delete the leaves first and eventually get rid of the root
<span class="fc" id="L85">            zk.delete(tree.get(i), -1, cb, ctx); //Delete all versions of the node with -1.</span>
        }
<span class="fc" id="L87">    }</span>
    
    /**
     * BFS Traversal of the system under pathRoot, with the entries in the list, in the 
     * same order as that of the traversal.
     * &lt;p&gt;
     * &lt;b&gt;Important:&lt;/b&gt; This is &lt;i&gt;not an atomic snapshot&lt;/i&gt; of the tree ever, but the
     *  state as it exists across multiple RPCs from zkClient to the ensemble.
     * For practical purposes, it is suggested to bring the clients to the ensemble 
     * down (i.e. prevent writes to pathRoot) to 'simulate' a snapshot behavior.   
     * 
     * @param zk the zookeeper handle
     * @param pathRoot The znode path, for which the entire subtree needs to be listed.
     * @throws InterruptedException 
     * @throws KeeperException 
     */
    public static List&lt;String&gt; listSubTreeBFS(ZooKeeper zk, final String pathRoot) throws 
        KeeperException, InterruptedException {
<span class="fc" id="L105">        Deque&lt;String&gt; queue = new LinkedList&lt;String&gt;();</span>
<span class="fc" id="L106">        List&lt;String&gt; tree = new ArrayList&lt;String&gt;();</span>
<span class="fc" id="L107">        queue.add(pathRoot);</span>
<span class="fc" id="L108">        tree.add(pathRoot);</span>
        while (true) {
<span class="fc" id="L110">            String node = queue.pollFirst();</span>
<span class="fc bfc" id="L111" title="All 2 branches covered.">            if (node == null) {</span>
<span class="fc" id="L112">                break;</span>
            }
<span class="fc" id="L114">            List&lt;String&gt; children = zk.getChildren(node, false);</span>
<span class="fc bfc" id="L115" title="All 2 branches covered.">            for (final String child : children) {</span>
<span class="fc" id="L116">                final String childPath = node + &quot;/&quot; + child;</span>
<span class="fc" id="L117">                queue.add(childPath);</span>
<span class="fc" id="L118">                tree.add(childPath);</span>
<span class="fc" id="L119">            }</span>
<span class="fc" id="L120">        }</span>
<span class="fc" id="L121">        return tree;</span>
    }
    
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>